﻿from __future__ import division
from __future__ import with_statement
from path import path
import es
import popuplib
import langlib
import random
import votelib
import cfglib
import cmdlib
import playerlib
import gamethread

###############################
# Special Thanks to Tha Pwned #
###############################

config = cfglib.AddonCFG(es.getAddonPath("customvotes") + "/settings.cfg")
config.text("**************************")
config.text("    Addon Settings        ")
config.text("**************************")
config.text("**************************")
config.text("    Votemap Settings      ")
config.text("**************************")
votemapon = config.cvar("votemap",   1, "1 = Enable 0 = Disable")
config.text("**************************")
config.text("    Votekick Settings     ")
config.text("**************************")
votekickon = config.cvar("votekick",   1, "1 = Enable 0 = Disable")
config.text("**************************")
config.text("    Voteban Settings      ")
config.text("**************************")
votebanon = config.cvar("voteban",   1, "1 = Enable 0 = Disable ")
bantime = config.cvar("bantime",   48, "How many Hours should the Player get banned? (Set it to 0 for Permanent Bann)")
config.text("**************************")
config.text("    Votemute Settings     ")
config.text("**************************")
votemuteon = config.cvar("votemute",   1, "1 = Enable 0 = Disable(Please when you have no SM or MA Disable it!)")
config.text("**************************")
config.text("    Nomintations Settings ")
config.text("**************************")
nominationon = config.cvar("nominationon",   1, "1 = Enable 0 = Disable")
maxnomintations = config.cvar("maxnomintations",   6, "Set the Number how man Map can be nominated")
config.text("**************************")
config.text("    RTV Settings          ")
config.text("**************************")
rtvon = config.cvar("rtvon",   1, "1 = Enable 0 = Disable")
rtvvotetime = config.cvar("rtvvotetime",   30, "Set the Time how long the RockTheVote is running")
config.text("**************************")
config.text("    Admin Settings        ")
config.text("**************************")
admins = config.cvar("admins", "STEAM_0:1:11481378,STEAM_0:1:12345678", "Set the Admins (split by comma if you want to add more)")
admin_mute_allow = config.cvar("admin_mute_allow",   0, "Set to 1 If you want to Disable votemutefunction when Admin is on Server")
admin_ban_allow = config.cvar("admin_ban_allow",   0, "Set to 1 If you want to Disable votebanfunction when Admin is on Server")
admin_kick_allow = config.cvar("admin_kick_allow",   0, "Set to 1 If you want to Disable votekickfunction when Admin is on Server")
config.write()

info = es.AddonInfo()
info.name          = 'Customvotes'
info.version       = '1.1 Final'
info.basename      = 'customvotes'
info.url           = 'http://addons.eventscripts.com/addons/view/' + info.basename
info.author        = 'RoOF'
es.ServerVar(info.basename, info.version, 'customvotes').makepublic()


nominations = []
addmaps = []
voteR_1 = []
voteM = {}
voteK = {}
voteB = {}
voteMu = {}
voteR_2 = {}
voteMuList = set() 

mapcyclefile = path(str(es.ServerVar('eventscripts_gamedir'))).joinpath('mapcycle.txt')

def selectM(voter, choice, popupid):
	global voteM
	v_steamid = es.getplayersteamid(voter)
	if not voteM.has_key(choice):
		voteM[choice] = []
	vname = es.getplayername(voter)
	for useridx in es.getUseridList():
		player = playerlib.getPlayer(useridx)
		vpercent = len(voteM[choice])
		vProzent = int(round(es.getplayercount()/2)+ 1)
		if not v_steamid in voteM[choice]:
			voteM[choice].append(v_steamid)
			if vpercent >= vProzent:
				gamethread.delayed(5, es.server.queuecmd, "changelevel %s" % choice)  
				es.tell(useridx, '#multi', text('mapchanged',{'choice': choice,'percent': vpercent,'prozent': vProzent},player.get('lang')))   
				continue
			es.tell(useridx, '#multi', text('mapnotchanged',{'name': vname,'choice': choice,'percent': vpercent,'prozent': vProzent},player.get('lang')))       
		else:
			es.tell(useridx, '#multi', text('mapnotchanged',{'name': vname,'choice': choice,'percent': vpercent,'prozent': vProzent},player.get('lang')))       


def selectK(voter, choice, popupid):
	global voteK
	v_steamid = es.getplayersteamid(voter)
	if not voteK.has_key(choice):
		voteK[choice] = []
	vname = es.getplayername(voter)
	cname = es.getplayername(choice)
	for useridx in es.getUseridList():
		player = playerlib.getPlayer(useridx)
		vpercent = len(voteK[choice])
		vProzent = int(round(es.getplayercount()/2)+ 1)
		if not v_steamid in voteK[choice]:
			voteK[choice].append(v_steamid)
			if vpercent >= vProzent:
				es.tell(useridx, '#multi', text('kicked',{'name': cname,'percent': vpercent,'prozent': vProzent},player.get('lang')))           
				es.server.queuecmd("kickid %s You have been VoteKicked" % choice)
				continue
			es.tell(useridx, '#multi', text('notkicked',{'name': vname,'namech': cname,'percent': vpercent,'prozent': vProzent},player.get('lang')))                      
		else:
			es.tell(useridx, '#multi', text('notkicked',{'name': vname,'namech': cname,'percent': vpercent,'prozent': vProzent},player.get('lang')))

def selectB(voter, choice, popupid):
	global voteB
	v_steamid = es.getplayersteamid(voter)
	if not voteB.has_key(choice):
		voteB[choice] = []
	vname = es.getplayername(voter)
	cname = es.getplayername(choice)
	for useridx in es.getUseridList():
		player = playerlib.getPlayer(useridx)
		vpercent = len(voteB[choice])
		vProzent = int(round(es.getplayercount()/2)+ 1)
		if not v_steamid in voteB[choice]:
			voteB[choice].append(v_steamid)
			if vpercent >= vProzent:
				if bantime != 0:
					bantimerechner = bantime * 3600
					es.server.queuecmd("kickid %s You have been VoteBanned" % choice)
					es.server.queuecmd("banid %s %s" % (bantimerechner, es.getplayersteamid(choice)))
				else:
					es.server.queuecmd("kickid %s You have been VoteBanned" % choice)
					es.server.queuecmd('banid bantimerechner %s;writeid' % es.getplayersteamid(choice))
				es.tell(useridx, '#multi', text('banned',{'name': cname,'percent': vpercent,'prozent': vProzent},player.get('lang')))
				continue
			es.tell(useridx, '#multi', text('notbanned',{'name': vname,'namech': cname,'percent': vpercent,'prozent': vProzent},player.get('lang')))      
		else:
			es.tell(useridx, '#multi', text('notbanned',{'name': vname,'namech': cname,'percent': vpercent,'prozent': vProzent},player.get('lang')))


def selectMute(voter, choice, popupid):
	global voteMu
	v_steamid = es.getplayersteamid(voter)
	if not voteMu.has_key(choice):
		voteMu[choice] = []
	vname = es.getplayername(voter)
	cname = es.getplayername(choice)
	for useridx in es.getUseridList():
		player = playerlib.getPlayer(useridx)
		vpercent = len(voteMu[choice])
		vProzent = int(round(es.getplayercount()/2)+ 1)
		if not v_steamid in voteMu[choice]:
			voteMu[choice].append(v_steamid)
			if vpercent >= vProzent:
				voteMuList.add(choice)
				es.tell(useridx, '#multi', text('muted',{'name': cname,'percent': vpercent,'prozent': vProzent},player.get('lang')))
				continue
			es.tell(useridx, '#multi', text('notmuted',{'name': vname,'namech': cname,'percent': vpercent,'prozent': vProzent},player.get('lang')))     
		else:
			es.tell(useridx, '#multi', text('notmuted',{'name': vname,'namech': cname,'percent': vpercent,'prozent': vProzent},player.get('lang')))
	
	
def selectNom(voter, choice, popupid):
	for useridx in es.getUseridList():
		es.tell(useridx, '#multi', text('nominated',{'name': es.getplayername(voter),'choice': choice},playerlib.getPlayer(useridx).get('lang')))       
	if choice not in nominations:
		nominations.append(choice)
		if len(nominations) > maxnomintations:
			nominations.pop(0)
	
	
def voteRtv1(userid, args):
	global voteR_1
	v_steamid = es.getplayersteamid(userid)
	vname = es.getplayername(userid)
	for useridx in es.getUseridList():
		vpercent = len(voteR_1)
		vProzent = int(round(es.getplayercount()/2)+ 1)
		player = playerlib.getPlayer(useridx)
		if not votelib.isrunning('rtv_vote'):
			if not v_steamid in voteR_1:
				voteR_1.append(v_steamid)
				if vpercent >= vProzent:
					es.emitsound("player", userid, "customvotes/actions/startyourvoting.mp3", 1.0, 0.0)
					voteRtv2(useridx)
					es.tell(useridx, '#multi', text('rtvstart',{'percent': vpercent,'prozent': vProzent},player.get('lang')))
					continue
				es.tell(useridx, '#multi', text('rtvnotstart',{'name': vname,'percent': vpercent,'prozent': vProzent},player.get('lang')))
			else:
				es.tell(useridx, '#multi', text('rtvnotstart',{'name': vname,'percent': vpercent,'prozent': vProzent},player.get('lang'))) 
		else:
			es.tell(userid, '#multi', text('alreadyactive',{},playerlib.getPlayer(userid).get('lang')))

	
def voteRtv2(userid):
	nominations.extend(random.sample(mapcycle.difference(nominations), maxnomintations - len(nominations)))
	if votelib.exists('rtv_vote'):
		votelib.delete('rtv_vote')
	rtv_vote = votelib.create("rtv_vote", checkResults, submit)
	rtv_vote.setquestion("Customvotes :\nRockTheVote")
	for x in nominations:
		rtv_vote.addoption(x)
		addmaps.append(x)
	rtv_vote.start(rtvvotetime)


def checkResults(votename, win, winname, winvotes, winpercent, total, tie, cancelled):
	for useridx in es.getUseridList():
		es.playsound(useridx, 'customvotes/actions/endofvote.mp3', 1.0)
		if win or total == 0:
			zufallsmap = random.choice(addmaps)
			gamethread.delayed(5, es.server.queuecmd, "changelevel %s" % zufallsmap) 
			es.tell(useridx, '#multi', text('rtvwinner',{'win': zufallsmap},playerlib.getPlayer(useridx).get('lang')))
		else:
			gamethread.delayed(5, es.server.queuecmd, "changelevel %s" % winname)  
			es.tell(useridx, '#multi', text('rtvwinner',{'win': winname},playerlib.getPlayer(useridx).get('lang')))

	
		


def submit(voter, votename, choice, choicename):
	global voteR_2 
	for useridx in es.getUseridList():
		es.tell(useridx, '#multi', text('rtvvote',{'name': es.getplayername(voter),'choice': choicename},playerlib.getPlayer(useridx).get('lang')))
	v_steamid = es.getplayersteamid(voter)
	if not voteR_2.has_key(choice):
		voteR_2[choice] = []
	if not v_steamid in voteR_2[choice]:
		voteR_2[choice].append(v_steamid)

		

def getMapCycle():
	with open(mapcyclefile) as myfile:
		return set(filter(None, map(str.strip, myfile.readlines())))

mapcycle = getMapCycle()



def ticklistener_mute():
        for allPlayers in es.getUseridList():
                for choice in voteMuList:
                        es.voicechat("nolisten",choice,allPlayers)

def sayfilter_mute(userid, text, teamonly):
        if userid in voteMuList:
                return 0, None, None
        return userid, text, teamonly





def player_disconnect(ev):
	steamid = ev['networkid']
	userid = ev['userid']
	for x in voteM.copy():
  		if steamid in voteM[x]:
    			voteM[x].remove(steamid)
	for x in voteK.copy():
  		if steamid in voteK[x]:
    			voteK[x].remove(steamid)
	for x in voteB.copy():
  		if steamid in voteB[x]:
    			voteB[x].remove(steamid)	
	for x in voteMu.copy():
  		if steamid in voteMu[x]:
    			voteMu[x].remove(steamid)
	for x in voteMuList.copy():
		if userid in voteMuList[x]:
			voteMuList[x].discard(userid)
	if steamid in voteR_1:
		voteR_1.remove(steamid)



def load():
	global text
	config.execute()
	download()
	text = langlib.Strings(es.getAddonPath("customvotes") + "/strings.ini")
	if votemapon == 1:
		cmdlib.registerSayCommand('!votemap', voteMa, "Choose a Map1")
		cmdlib.registerSayCommand('votemap', voteMa, "Choose a Map2")
	if votekickon == 1:
		cmdlib.registerSayCommand('!votekick', voteKi, "Kick a Player1")
		cmdlib.registerSayCommand('votekick', voteKi, "Kick a Player2")
	if votebanon == 1:
		cmdlib.registerSayCommand('!voteban', voteBa, "Ban a Player1")
		cmdlib.registerSayCommand('voteban', voteBa, "Ban a Player2")
	if votemuteon == 1:
		es.addons.registerTickListener(ticklistener_mute)
		es.addons.registerSayFilter(sayfilter_mute)
		cmdlib.registerSayCommand('!votemute', voteMut, "Mute a Player1")
		cmdlib.registerSayCommand('votemute', voteMut, "Mute a Player2")
	if nominationon == 1:
		cmdlib.registerSayCommand('nominate', voteNo, "Nominate a Map")
	if rtvon == 1:
		cmdlib.registerSayCommand('rtv', voteRtv1, "Rock the Vote1")
		cmdlib.registerSayCommand('rockthevote', voteRtv1, "Rock the Vote2")

def unload():
	if votemapon == 1:
		voteM.clear()
		cmdlib.unregisterSayCommand('!votemap')
		cmdlib.unregisterSayCommand('votemap')
	if votekickon == 1:
		voteK.clear()
		cmdlib.unregisterSayCommand('!votekick')
		cmdlib.unregisterSayCommand('votekick')
	if votebanon == 1:
		voteB.clear()
		cmdlib.unregisterSayCommand('!voteban')
		cmdlib.unregisterSayCommand('voteban')
	if votemuteon == 1:
		voteMu.clear()
		cmdlib.unregisterSayCommand('!votemute')
		cmdlib.unregisterSayCommand('votemute')
		es.addons.unregisterTickListener(ticklistener_mute)
		es.addons.unregisterSayFilter(sayfilter_mute)
	if nominationon == 1:
		del nominations[:]
		cmdlib.unregisterSayCommand('nominate')
	if rtvon == 1:
		voteR_2.clear()
		del voteR_1[:]
		del addmaps[:]
		cmdlib.unregisterSayCommand('rtv')
		cmdlib.unregisterSayCommand('rockthevote')


def es_map_start(ev):
	download()
	if votemapon == 1:
		voteM.clear()
	if votekickon == 1:
		voteK.clear()
	if votebanon == 1:
		voteB.clear()
	if votemuteon == 1:
		voteMu.clear()
	if nominationon == 1:
		del nominations[:]
	if rtvon == 1:
		voteR_2.clear()
		del voteR_1[:]
		del addmaps[:]
	


def voteMa(userid, args):
	name = 'votemap_menu'
	if popuplib.exists(name):
		popuplib.delete(name)
	votemapmenu = popuplib.easymenu(name, '_popup_choice', selectM)
	votemapmenu.settitle('Customvotes:\nRequired Votes for changing Map is: '+ str(int(round(es.getplayercount()/2)+ 1))+'\nChoose the Map that you want to Play')
	f = open(es.getString('eventscripts_gamedir') + '/mapcycle.txt')
	m = f.read().split('\n')
	f.close()
	for x in m:
		if x in voteM:
			votemapmenu.addoption(x, '['+str(len(voteM[x]))+'] '+x)
		else:
			votemapmenu.addoption(x, '[0] '+ x)
	votemapmenu.send(userid)


def voteKi(userid, args):
	name = 'votekick_menu'
	if popuplib.exists(name):
		popuplib.delete(name)
	votekickmenu = popuplib.easymenu(name, '_popup_choice', selectK)
	votekickmenu.settitle('Customvotes:\nRequired Votes for Kicking a Player is: '+ str(int(round(es.getplayercount()/2)+ 1))+'\nChoose the Player that you want to Kick')
	for player in playerlib.getUseridList('#human'):
		if player in voteK:
			votekickmenu.addoption(player, '['+str(len(voteK[player]))+'] '+es.getplayername(player))
		else:
			votekickmenu.addoption(player, '[0] '+ es.getplayername(player))
		if admin_kick_allow == 1:
			if not es.getplayersteamid(player) in str(admins).split(','):
				votekickmenu.send(userid)
			else:
				es.tell(player, '#multi', text('commanddisable',{},playerlib.getPlayer(player).get('lang')))
		else:
			votekickmenu.send(userid)

def voteBa(userid, args):
	name = 'voteban_menu'
	if popuplib.exists(name):
		popuplib.delete(name)
	votebanmenu = popuplib.easymenu(name, '_popup_choice', selectB)
	votebanmenu.settitle('Customvotes:\nRequired Votes for Banning a Player is: '+ str(int(round(es.getplayercount()/2)+ 1))+'\nChoose the Player that you want to Ban')
	for player in playerlib.getUseridList('#human'):
		if player in voteB:
			votebanmenu.addoption(player, '['+str(len(voteB[player]))+'] '+es.getplayername(player))
		else:
			votebanmenu.addoption(player, '[0] '+ es.getplayername(player))
		if admin_ban_allow == 1:
			if not es.getplayersteamid(player) in str(admins).split(','):
				votebanmenu.send(userid)
			else:
				es.tell(player, '#multi', text('commanddisable',{},playerlib.getPlayer(player).get('lang')))
		else:
			votebanmenu.send(userid)

def voteMut(userid, args):
	name = 'votemute_menu'
	if popuplib.exists(name):
		popuplib.delete(name)
	votemutemenu = popuplib.easymenu(name, '_popup_choice', selectMute)
	votemutemenu.settitle('Customvotes:\nRequired Votes for Muting a Player is: '+ str(int(round(es.getplayercount()/2)+ 1))+'\nChoose the Player that you Want to Mute')
	for player in playerlib.getUseridList('#human'):
		if not player in voteMuList:
			if player in voteMu:
				votemutemenu.addoption(player, '['+str(len(voteMu[player]))+'] '+es.getplayername(player))
			else:
				votemutemenu.addoption(player, '[0] '+ es.getplayername(player))
		if admin_mute_allow == 1:
			if not es.getplayersteamid(player) in str(admins).split(','):
				votemutemenu.send(userid)
			else:
				es.tell(player, '#multi', text('commanddisable',{},playerlib.getPlayer(player).get('lang')))
		else:
			votemutemenu.send(userid)
	
def voteNo(userid, args):
	name = 'nominate_menu'
	if popuplib.exists(name):
		popuplib.delete(name)
	votemapmenu = popuplib.easymenu(name, '_popup_choice', selectNom)
	votemapmenu.settitle('Customvotes:\nChoose a Map that you want to nominate \nand then type (rtv) or (rockthevote) in the Chat')
	f = open(es.getString('eventscripts_gamedir') + '/mapcycle.txt')
	m = filter(lambda x: x not in nominations,(f.read().split('\n')))
	f.close()
	for x in m:
		votemapmenu.addoption(x, x)
	if not votelib.isrunning('rtv_vote'):
		if es.getplayersteamid(userid) not in voteR_1:
			votemapmenu.send(userid)
		else:
			es.tell(userid, '#multi', text('registered',{},playerlib.getPlayer(userid).get('lang')))
	else:
		es.tell(userid, '#multi', text('alreadyactive',{},playerlib.getPlayer(userid).get('lang')))



def download():
	es.stringtable('downloadables', 'sound/customvotes/actions/startyourvoting.mp3')
	es.stringtable('downloadables', 'sound/customvotes/actions/endofvote.mp3')
	
